package org.artifactory.config;

import com.jfrog.sysconf.SysConfig;
import com.jfrog.sysconf.SysConfigConstants;
import org.artifactory.api.config.ArtifactorySystemConfig;

/**
 * Artifactory system configuration. Stems from the global {@link com.jfrog.sysconf.SysConfig}.
 *
 * @author Uriah Levy
 */
public class ArtifactorySystemConfigImpl implements ArtifactorySystemConfig {

    private final SysConfig sysConfig;

    ArtifactorySystemConfigImpl(SysConfig sysConfig) {
        this.sysConfig = sysConfig;
    }

    @Override
    public String getRouterUrl() {
        return sysConfig.helper().getRouterUrl();
    }

    @Override
    public boolean isRouterEnabled() {
        return sysConfig.getBoolean(SysConfigConstants.KEY_ROUTER_ENABLED, true);
    }

    @Override
    public SysConfig getSysConfig() {
        return sysConfig;
    }

    @Override
    public String getNodeId() {
        return sysConfig.get(SysConfigConstants.KEY_NODE_ID).orElse(null);
    }
}